.686			
.MMX
.model 	flat, stdcall
option 	casemap:none

include	c:\masm32\include\windows.inc
include	c:\masm32\include\kernel32.inc
include	c:\masm32\include\masm32.inc
include	c:\masm32\macros\macros.asm
include	c:\masm32\macros\timers.asm
includelib	c:\masm32\lib\kernel32.lib
includelib	c:\masm32\lib\masm32.lib

mm0 equ MM0
mm1 equ MM1
mm2 equ MM2
mm3 equ MM3
mm4 equ MM4
mm5 equ MM5
mm6 equ MM6
mm7 equ MM7



Main		proto

H2dw	 	proto :dword
h2d		proto :dword



.data

	LOOP_COUNT	EQU	100000000		; 1M iterations per timing result

 align 4
	MyValue			dd 1C2B3A4Bh	 
	retva					dd 0
	SzH2DwH			db  "Hex2Dw - hutch : ",0,0
	SzH2DwL			db  "Hex2Dw - lingo : ",0,0

align 4
     tbl1 \
        db 00h,10h,20h,30h,40h,50h,60h,70h,80h,90h,0,0,0,0,0,0      ; 63
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h,0,0,0,0,0,0,0,0,0      ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h

      tbl2 \
        db 00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0,0,0,0,0,0      ; 63
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh,0,0,0,0,0,0,0,0,0            ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh

        ; sub 48 from each offset table


align 4
MyHexNumber 	db		"FD19ED27",0
;MyHexNumber 	db		"1D19ED27",0


.code
Start:
	Invoke	Main
	Invoke	ExitProcess, 0
Main	Proc
	mov	eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    	print	chr$(13,10,13,10,"Hex2Dword  Tests:",13,10,13,10)
; ------------------------------------------------------------------------------
  	comment * Hex2Dw by Hutch  *
	print	addr 	SzH2DwH
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	 h2d, addr  MyHexNumber 
	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$("  clocks; Result: ")
  	mov	eax, retva
	print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; -----------------------------------------------------------------------------
  	comment * Hex2Dw by lingo  *
	print	addr 	SzH2DwL
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	H2dw, addr  MyHexNumber 
	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$("  clocks; Result: ")
	mov	eax, retva
	print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; -----------------------------------------------------------------------------

 mov	eax, input(13,10," Press ENTER to exit...")
	ret
Main	EndP

; ------------------------------------------------------------------------------
comment * Hex2Dword  by Hutch *
Align 16
h2d	proc			phex:DWORD
		LOCAL	var   :DWORD

		push		esi
		push		edi
		mov		esi, phex
		lea		edi, var

		movzx	eax, BYTE PTR [esi]
		movzx	edx, BYTE PTR [esi+1]
		mov		cl, [tbl1+eax-48]
		add		cl, [tbl2+edx-48]
		mov		[edi+3], cl

		movzx	eax, BYTE PTR [esi+2]
		movzx	edx, BYTE PTR [esi+3]
		mov		cl, [tbl1+eax-48]
		add		cl, [tbl2+edx-48]
		mov		[edi+2], cl

		movzx	eax, BYTE PTR [esi+4]
		movzx	edx, BYTE PTR [esi+5]
		mov		cl, [tbl1+eax-48]
		add		cl, [tbl2+edx-48]
		mov		[edi+1], cl

		movzx	eax, BYTE PTR [esi+6]
		movzx	edx, BYTE PTR [esi+7]
		mov		cl, [tbl1+eax-48]
		add		cl, [tbl2+edx-48]
		mov		[edi+0], cl

		mov		eax, [edi]
		pop		edi
		pop		esi
		ret
h2d	endp

OPTION PROLOGUE:none
OPTION EPILOGUE:none
comment * Hex2Dword by lingo *
Align 16
H2dw	proc		lHexValue:dword
			mov	eax, [esp+4]	; eax->buffer with string
			mov	[esp+4], ebx	
			mov	ecx, [eax]
			mov	ebx, [eax+4]

			movzx	eax, cl
			movzx edx, word ptr [tbl1+eax-48-1]
			mov	al, ch
			bswap ecx
			add	dh, [tbl2+eax-48]

			mov	al, cl
			mov	dl, [tbl2+eax-48]
			mov	al, ch
			add	dl, [tbl1+eax-48]

			movzx	ecx, bl
			movzx	eax, word ptr [tbl1+ecx-48-1]
			mov	cl, bh
			bswap ebx
			add	ah, [tbl2+ecx-48]

			mov	cl, bl
			mov	al, [tbl2+ecx-48]
			mov	cl, bh
			add	al, [tbl1+ecx-48]

			shl	edx, 16
			mov	ebx,[esp+4]
			add	eax, edx
			ret	4
H2dw	endp
OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

End	Start


